/*
   Upravy se tykaji funkci
     1) createScene()   ... modelovani a umisteni objektu ve scene
     2) setProjection() ...  nastaveni projekce
     3) menu a okna

    Interakce: a) menu a submenu
	       b) klavesnice
               
*/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "glut.h"
   
#define PI 3.14159265
#define GAP 50 
#define OKNOX 532+GAP*3
#define OKNOY 532+GAP*3

GLuint width  = OKNOX;  
GLuint height = OKNOY, window, i = 0;   

GLfloat x = 0.3, y = 0.0, z = 0.0;
GLint u = 0, i, j;
GLfloat f, pozicex, pozicey, pozicez, pozicex1, pozicey1, pozicez1, j2;
GLboolean vpravo = TRUE, nahoru = FALSE, dolu = FALSE, rotace = FALSE, zastaveni = TRUE;
GLboolean toceni = FALSE, jehlan = FALSE;
GLdouble size=0.1;


void
main_reshape(int width,  int height) 
{	
    glViewport(0, 0, width, height);
}

void

main_display(void)
{

    glViewport(0, 0, width, height);
	
    glMatrixMode(GL_MODELVIEW);

    glLoadIdentity();
	glClear(GL_COLOR_BUFFER_BIT |GL_DEPTH_BUFFER_BIT);


if (toceni)
{
	pozicex1 = cos((PI*j2)/360);
	pozicey1 = sin((PI*j2)/360);
	pozicez1 = 0.2;
	j2+=1;
}

if (jehlan)
{ 
	pozicex1 =  x+0.4;
	pozicey1 =  y+0.3;
	pozicez1 =  z+0.6;
}

if (toceni)
{
	gluLookAt(pozicex1, pozicey1, pozicez1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.1);
}
if (jehlan)
{
	gluLookAt(pozicex1, pozicey1, pozicez1,pozicex1-0.3, pozicey1-0.3, pozicez1-0.3,0.0, 0.0, 0.1);
}
if (zastaveni)
{
	gluLookAt(0.6,0.0, 0.1, 0.0, 0.0, 0.0 ,0.0, 0.0, 0.1);
}
		
	pozicey = pozicey+0.005;
	pozicex = cos((PI*j)/360)/4+0.3;
	pozicez = sin((PI*j)/360)/4+0.3;
	j+=5;


	if ((z>=0.60000) && !(vpravo) && !(dolu) && (nahoru)) {nahoru = 0; dolu=1; vpravo=0; rotace=1;};
	if ((z<=0.00000) && !(vpravo) && !(nahoru) && (dolu)) {vpravo = 1; dolu=0; nahoru=0; rotace=1;};
	if ((y>=0.300000) && !(dolu) && !(nahoru) && (vpravo)) {nahoru=1; vpravo=0; dolu=0; rotace =1;};
	if (!rotace)
	{
		if (vpravo) y=y+0.01;
		if (nahoru)  {y=y-0.005; z=z+0.01; x=x-0.01;};
		if (dolu)	 {y=y-0.005; z=z-0.01; x=x+0.01;};
	}


	glPushMatrix();
	glTranslatef(0.0, 0.0, 0.2);
	glRotatef(i,0.25,0.25,0.0);
	glCallList(1);
	glPopMatrix();
	i++;


	glPushMatrix();
	glTranslatef(x, y, z);
	glRotatef(45,0.0, 1.0, 0.0);
	if (rotace)
	{	
		u=u+2;
		glRotatef(u,1.0,0.0,0.0);
		glCallList(2);
		glRotatef(-u,1.0,0.0,0.0);
		if ((u % 120)==0) 
		{
			rotace=FALSE;
			if (u==360) u=0;
		}
	}
	else 
	{
		glRotatef(u,1.0,0.0,0.0);
		glCallList(2);
		glRotatef(-u,1.0,0.0,0.0);
	}
	glPopMatrix();


	glPushMatrix();
	glTranslatef(pozicex,pozicey,pozicez);
	glRotatef(13.0,0.1,0.1,0.1);
	glCallList(3);
	glPopMatrix();
	if (pozicey>1.1) pozicey=-1.1;


		glCallList(4); 
        

	glutPostRedisplay(); 
	glutSwapBuffers(); 
}


void main_menu(int value)
{
    switch (value) 
	{
    case 's':
		if (!zastaveni) {toceni=FALSE; jehlan=FALSE; zastaveni=TRUE;};
	break;
    case 'j':
		if (!jehlan) {toceni=FALSE; jehlan=TRUE; zastaveni=FALSE;};
	break;
    case 'o':
		if (!toceni) {toceni=TRUE; jehlan=FALSE; zastaveni=FALSE;};
	break;
	}
}

void
world_reshape(int width, int height)
{
	glutPostRedisplay();     
}

void 
world_idle(void)
{
     glutPostRedisplay();
}


int
main(int argc, char** argv)
{
   GLfloat mat_ambient[] = { 1.0, 1.0, 1.0, 1.0 };
   GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0 };
   GLfloat light_position[] = { 1.0, 0.0, 0.0, 1.0 };
   GLfloat lm_ambient[] = { 0.9, 0.9, 0.9, 1.0 };

	glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE); 
    glutInitWindowSize(width, height);
    glutInitWindowPosition(20, 20);
    glutInit(&argc, argv);

    window = glutCreateWindow("Projekt - OpenGL");
    glutReshapeFunc(main_reshape);
    glutDisplayFunc(main_display);
	glutIdleFunc (world_idle);
	glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();


   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
   glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
   glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 30.0);
   glLightfv(GL_LIGHT0, GL_POSITION, light_position);
   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lm_ambient); 
    
   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);
   glEnable(GL_DEPTH_TEST);
	glShadeModel (GL_FLAT);
	glEnable(GL_COLOR_MATERIAL);
	glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,0.9);
	glutCreateMenu(main_menu);
/*MENU*/
	glutAddMenuEntry("Pohled shora", 's');
	glutAddMenuEntry("Draha jehlanu", 'j');
	glutAddMenuEntry("Otaceni kamery dokola", 'o');

	glNewList(4, GL_COMPILE); /*koule - spirala*/
		glMaterialf(GL_FRONT_AND_BACK, GL_DIFFUSE, 1.0);
		glColor3f(1.0, 0.0, 0.0);
		glutSolidSphere(0.2, 10, 10);
    glEndList();

	glNewList(1, GL_COMPILE); /*ctverec - otaceni*/
		glMaterialf(GL_FRONT_AND_BACK, GL_DIFFUSE, 1.0);
		glColor3f(0.0, 0.0, 1.0);
		glutSolidCube(0.15);

	glEndList();
			
	glNewList(2, GL_COMPILE); /*jehlan - pohyb do trojuhelniku*/

		glMaterialf(GL_FRONT_AND_BACK, GL_DIFFUSE, 1.0);
		glColor3f(0.0, 1.0, 0.0);
		glutSolidCone(0.1, 0.35, 5, 3);
	glEndList();

	glNewList(3, GL_COMPILE); /*koule - spirala*/
		glMaterialf(GL_FRONT_AND_BACK, GL_DIFFUSE, 1.0);
		glColor3f(1.0, 0.0, 0.0);
		glutSolidSphere(0.2, 10, 10);
    glEndList();
	
	glNewList(4,GL_COMPILE); /*rovina*/

		   glMaterialf(GL_FRONT_AND_BACK, GL_DIFFUSE, 1.0);

		glColor3f(1.0, 1.0, 0);
		glBegin(GL_QUADS);
			glVertex3f (1.0,  1.0, -1.0);
			glVertex3f (-1.0, 1.0, -1.0);
			glVertex3f (-1.0, -1.0, -1.0);
			glVertex3f (1.0,  -1.0, -1.0);
		glEnd();
	glEndList();

	glutAttachMenu(GLUT_RIGHT_BUTTON); 
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glutMainLoop();

    return 0;
}

